#ifndef HEXAGONE_H
#define HEXAGONE_H

#include "Platform.h"
#include "Gfx.h"

const float Racine3 = 1.75;
const int NOCELL = -1;

// Algo
// 1- Initialiser Rayon, nb_lignes, nb_colonnes : Maillage()
// 2- Calculer RayonRacine3, numeroLigne0, numeroLigne60, numeroLigne120 : Maillage()
// 3- Pour un point (xsouris, ysouris) determiner numeroLigne0,
// numeroLigne60, numeroLigne120 : NumerosLignes()

// 4- Pour numeroLigne0, numeroLigne60, numeroLigne120, determiner les numeros de lignes du
// centre le l'hexagone c'est a dire nL0, nL60 et nL120 : NumerosLignesCentre()
// 5- Calculer point (X, Y) NumerosLignes() intersection de nL0 et nL60 : PointXYIntersection()
// 6- Pour le point (X, Y) determiner le numero de cellule : ReturnCell()

// Cellule
class Cell {
public:
  Cell();
  ~Cell(){;};
  void SetCenter(int x, int y);
  int GetX() { return xcentre; };
  int GetY() { return ycentre; };
  
  void DrawCell (gfxbitmap *bitmap, int rayon, UInt32 color);
  void SetNeighbour( int nord, int nordest, int sudest, int sud, int sudwest, int nordwest );
  int GetNo() { return No; };
  int GetNE() { return NE; };
  int GetSE() { return SE; };
  int GetSu() { return Su; };
  int GetSW() { return SW; };
  int GetNW() { return NW; };
  
private:
  int xcentre, ycentre;
  int No, NE, SE, Su, SW, NW; // Voisins
};

class Maillage {
private:
  int Rayon; // Rayon de base
  float RayonRacine3;  // sqrt(3)*Rayon
  int nb_lignes;       // Nombre d'hexagones par ligne
  int nb_colonnes; // Nombre d'hexagones par colonne
  Cell *cellules; // Tableau de cellules
  //int cellundermouse; // indice de la cellule sous le curseur de la souris
  
  void NumerosLignes( int xsouris,
                  int ysouris,
                  int &numeroligne0,
                  int &numeroligne60,
                  int &numeroligne120 );
  
  void NumerosLignesCentre( int &numeroligne0,
                           int &numeroligne60,
                           int &numeroligne120 );
  
  void PointXYIntersection( int numeroligne0,
                      int numeroligne60,
                      int &xcentre,
                      int &ycentre );
  int ReturnCell( int x, int y );

public:
  Maillage(int rayon, int nblignes, int nbcolonnes );
  ~Maillage();
  void ShowNeighbour(int numero);
  void DrawMaillage (gfxbitmap *bitmap, UInt32 color);
  void DrawCell (int cellule_n, gfxbitmap *bitmap, UInt32 color);
  int SolveCell( int x, int y );
  int GetWidth (void);
  int GetHeight (void);
};


#endif

