/*
 *  Copyright (C) 2008 Florent Bedoiseau (electronique.fb@free.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "Platform.h"
#include "Gfx.h"
#include "buzz.h"
#include "porsche.h"

#ifdef PSP
int SDL_main (int argc, char **argv) 
#else
int main ()
#endif
{
  GfxInit();
  GfxClear(0, GfxColor(255,255,255));
 
  GfxLine (0, 0,0,239, 319, GfxColor(0x0, 0xFF, 0x00));
  GfxLine (0, 239,0,0, 319, GfxColor(0x0, 0xFF, 0xFF));

  GfxLocate(0, 25);
  GfxString ("ABCDEFGHIJKLMNOPQRSTUVWXYZ",
             GfxColor (0xFF,0x50, 0xFF),
             GfxColor (0x50, 0x50, 0xFF));

  GfxLocate(0, 29);
  GfxString ("B", 5, 4);

  GfxLocate(39, 0);
  GfxString ("Salut poilu", GfxColor (0xFF,0xFF, 0xFF), GfxColor (0x2F,0x10, 0x3F));
  GfxString (" Ca beigne ?", GfxColor (0xFF,0x00, 0xFF), GfxColor (0x7F,0x80, 0x20));
  GfxLocate(39, 27);
  GfxString ("abcdefghijklmnopqrstuvwxyz", GfxColor (0x00,0x00, 0x80), GfxColor (0x80,0x00, 0x80));

  int i;
  for (i = 0; i < GFX_SCREEN_W; i+=2) {
    GfxPixel (0, i, 160, GfxColor (i%256,0x00, 255-(i%256)));
  }

  GfxRectangle (0, 20, 30, 90, 60, GfxColor(0x00, 0x7F, 0x20));
  GfxFillRectangle (0, 120, 130, 40, 140, GfxColor(0x00, 0x7F, 0x7F));

  GfxCircle (0, 100, 100, 40, GfxColor(0xFF, 0x7F, 0xFF));
  GfxUpdate ();

  GfxWaitTouched ();

  GfxClear(0, GfxColor(0xFF, 0xFF, 0xAF));
  GfxDrawPixmap (0, 0, 17, buzz_witdh, buzz_height, buzz);
  GfxUpdate ();

  GfxWaitTouched (); 

  GfxClear(0, GfxColor(0xFF, 0xA0, 0xAF));
  GfxDrawPixmap (0, 0, 0, porsche_witdh, porsche_height, porsche);
  GfxUpdate ();

  GfxWaitTouched ();

  GfxClear(0, GfxColor(0xAF, 0xAF, 0xAF) );
  GfxStringXY (0, "ABCD", 2, 316, GfxColor(0xAF, 0xAF, 0xAF), GfxColor (40,40,40));
  GfxStringXY (0, "ABCDEFGHIJKLMNO", 220, 99, GfxColor(255, 200, 255), GfxColor (255,255,255) );
  GfxStringXY (0,"THE END", 100, 160, GfxColor(100, 200, 200), GfxColor (255, 255, 255) );

  GfxUpdate ();  
  GfxWaitTouched ();

  GfxQuit();

  return 0;
}
