/*
 *  Copyright (C) 2008 Florent Bedoiseau (electronique.fb@free.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifdef LINUX
#include <stdio.h>
#include "SDL.h"
#endif

#include "Platform.h"
#include "Gfx.h"

#include "buzz.h"
#include "advanced-directory.h"
#include "gnome-lockscreen.h"
#include "gnome-netstatus-disconn.h"
#include "gnome-netstatus-tx.h"
#include "gnome-server-config.h"
#include "kpdf.h"

int main () {
  GfxInit();
  GfxClear(0, GfxColor (100, 100, 100));
  GfxRectangle (0, 0, 0, 240, 320, GfxColor (0,200,200));

  GfxDrawPixmap (0, 0, 17, buzz_witdh, buzz_height, buzz);

  GfxLocate(37, 1);
  GfxString ("Front Panel GUI V1.0", GfxColor(255,255,255), GfxColor(0,0,0));

  GfxLocate(38, 1);
  GfxString ("Please wait ...", GfxColor(255, 0, 255), GfxColor(0,0,0));
  
  GfxUpdate ();

  GfxWaitTouched ();

  GfxClear(0, 0xF0);
  GfxRectangle (0, 0, 0, 240, 320, GfxColor(100,0,200));

  GfxDrawPixmap (0, 24, 24, ic1_witdh, ic1_height, ic1);
  GfxDrawPixmap (0, 96, 24, ic2_witdh, ic2_height, ic2);
  GfxDrawPixmap (0, 168, 24, ic3_witdh, ic3_height, ic3);
  GfxDrawPixmap (0, 24, 96, ic4_witdh, ic4_height, ic4);
  GfxDrawPixmap (0, 96, 96, ic5_witdh, ic5_height, ic5);
  GfxDrawPixmap (0, 168, 96, ic6_witdh, ic6_height, ic6);

  GfxLocate(38, 1);
  GfxString ("Please wait ...", GfxColor(255,200,50), GfxColor(200,80,80));
  GfxUpdate ();
  
  GfxWaitTouched (); 
  
  GfxClear(0, GfxColor(100,140,140));
  UInt8 l, c, r, g, b;
  UInt32 color;
  l = 0;
  c = 0;
  for (r=0; r < 8; r++) {
	for (g=0; g < 8; g++) {
		for (b=0; b < 15; b++) {
		  color = GfxColor(r*36,g*36,b*18);
		  GfxFillRectangle (0, c*8, l*10, 7, 9, color);
		  if (c>=29) {
			c=0;
			l++;
		  }
		  else c++;
		}
	}
  }
  GfxUpdate ();
  GfxWaitTouched (); 

  GfxClear(0, GfxColor(20,80,120));
  gfxbitmap *p1 = GfxCreateBitmap (50, 50);
  GfxFillRectangle (p1, 10, 10, 30, 30, GfxColor (0x80, 0x20, 0xE0));
  GfxCircle (p1, 25, 25, 10, GfxColor(0xFF, 0x20, 0x20));
  GfxBlit (p1, 0, 0, 0, 60, 80 , 50, 50);
  GfxBlit (p1, 0, 0, 0, 0, 20 , 50, 50);
  GfxBlit (p1, 0, 0, 0, 160, 80 , 50, 50);
  GfxBlit (p1, 0, 0, 0, 160, 160 , 50, 50);
  GfxDeleteBitmap (p1);


  GfxUpdate ();
  GfxWaitTouched ();
  GfxClear(0, GfxColor(220,120,20));
  gfxbitmap *p2 = GfxCreateBitmapFromGif ("fox.gif");
  GfxSetClip (0, 0, 0, 80, 82); 
  UInt16 ww, hh;
  if (p2) {
    ww = p2->w;
    hh = p2->h;
    GfxBlit (p2, 0, 0, 0, 10, 10 , ww, hh);
    GfxBlit (p2, 0, 0, 0, 60, 60 , ww, hh);
    GfxDeleteBitmap (p2);
  }
  GfxSetNoClip (0);

  GfxUpdate ();
  GfxWaitTouched (); 
 
  GfxQuit();

  return 0;
}
