/*
 *  Copyright (C) 2008 Florent Bedoiseau (electronique.fb@free.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <string.h>

#include "AWC.h"
#include "AWD.h"

AWC::AWC (AWD *aParent, int ax, int ay, int aw, int ah, UInt8 Id) : AWVB (aParent,ax,ay,aw,ah,Id) {
}

AWC::~AWC () {
}

bool AWC::ProcessEvent (int mouse_move, UInt16 mx, UInt16 my, 
						int mouse_button, bool mb1, bool mb2,
						EVT& evt) {
  if (mouse_button) {
    if (mb1==true) {
      if (IsPressed ()) {
		evt = UnPressed ();
	  }
      else {
		evt = Pressed ();
	  }
	  return true;
    }
  }
  return false;
}

void AWC::Draw () {
  // Draw itself, then all the objects
  GfxFillRectangle(0,x,y,w,h,background_color); // All the area
  // Borders
  GfxLine(0,x,y,x+w-1,y, shadow_color_dark);
  GfxLine(0,x,y+h-1,x+w-1,y+h-1, shadow_color_light);
  GfxLine(0,x,y,x,y+h-1, shadow_color_dark);
  GfxLine(0,x+w-1,y,x+w-1,y+h-1, shadow_color_light);

  if (IsPressed()) {
    GfxLine(0,x+3,y+3,      x-3+w-1,y-3+h-1, foreground_color);
    GfxLine(0,x+4,y+3,      x-3+w-1,y-4+h-1, foreground_color);
    GfxLine(0,x+3,y+4,      x-4+w-1,y-3+h-1, foreground_color);

    GfxLine(0,x+3,y-3+h-1,  x-3+w-1,y+3, foreground_color);
    GfxLine(0,x+3,y-4+h-1,  x-4+w-1,y+3, foreground_color);
    GfxLine(0,x+4,y-3+h-1,  x-3+w-1,y+4, foreground_color);
  }
}

void AWC::UnDraw () {
}

// End of file
