/*
 *  Copyright (C) 2008 Florent Bedoiseau (electronique.fb@free.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "AWG.h"
#include "AWD.h"

AWG::AWG (AWD *aParent, int ax, int ay, int aw, int ah,
        bool vertical, float min, float max) : AW (aParent,ax,ay,aw,ah),
        _value(min), _min(min), _max(max), _vertical (vertical) {

}

AWG::~AWG () {
}

void AWG::SetValue (float value) {
    if (value > _max) _value=_max;
    else if (value < _min) _value=_min;
    else _value = value;

    if (IsVisible()) Draw ();
}

void AWG::Draw () {

     // Erase the area then draw the border
     GfxFillRectangle(0,x,y,w,h,foreground_color);
     GfxRectangle(0,x,y,w,h, shadow_color_light);

    if (_vertical == false) {
        UInt16 off = (UInt16) ((w * (_value - _min)) / (_max - _min) - 1);
        GfxFillRectangle (0, x + 1, y + 1, off, h - 2, background_color);
    }
    else {
        UInt16 off = (UInt16) ((h * (_value - _min)) / (_max - _min));
        GfxFillRectangle (0, x + 1, y + h - off, w - 2, off, background_color);
  }
  // GfxSetClip(0,0,0,0,0);
}


