/*
 *  Copyright (C) 2008 Florent Bedoiseau (electronique.fb@free.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <string.h>
#include "AWL.h"
#include "AWD.h"

AWL::AWL (AWD *aParent, int ax, int ay, int aw, int ah, const char *atext) : AW (aParent,ax,ay,aw,ah) {  
  if (atext) {
    text = new char [strlen (atext)+1];
    strcpy (text,atext);
  }
  else text=0;
}

AWL::~AWL () {
  if (text) delete [] text;
}

void AWL::SetText (const char *atext) {
  if (text) {
    delete [] text;
    text=0;
  }
  if (atext) {
    text = new char [strlen (atext)+1];
    strcpy (text,atext);
    if (IsVisible()) Draw ();
  }
}

void AWL::Draw () {
  if (text) {
    GfxSetClip(0,x,y,x+w-1,y+h-1);
    GfxStringXY(0, text, x, y, background_color, foreground_color);
    GfxSetClip(0,0,0,0,0);
  }
}

void AWL::UnDraw () {
}

EVT  AWL::Leave () {
#if DEBUG_EVT
  printf ("AWL::Leave\n");
#endif
  EVT evt;
  return evt;
}
void  AWL::Enter () {
#if DEBUG_EVT
  printf ("AWL::Enter\n");
#endif
}
