/*
 *  Copyright (C) 2008 Florent Bedoiseau (electronique.fb@free.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

// TODO
// Rendre insensible les boutons (devalides)
// BUG si dialogues crees supperposes

#include <stdio.h>

#include "AW.h"
#include "AWA.h" // Application
#include "AWD.h" // Dialog
#include "AWVB.h"// Base for the buttons
#include "AWB.h" // Button
#include "AWL.h" // Label
#include "AWC.h" // Check button
#include "AWI.h" // Icon button

#define ID_BUTTON_PREVIOUS 100
#define ID_BUTTON_NEXT     101
//
// THE TEST PROGRAM
//
int main () {
  GfxInit();

  GfxClear(0, GfxColor(200,200,200));
  AWA Application;
  AWD *dialogTemperature = new AWD (0,0,200,200,"Temperatures");
  AWB *buttonPrevious = new AWB (dialogTemperature, 5, 175, 20,20, ID_BUTTON_PREVIOUS,"<");
  AWB *buttonNext = new AWB (dialogTemperature, 175, 175, 20,20, ID_BUTTON_NEXT, ">");

  AWL *label = new AWL (dialogTemperature, 5, 20, 180, 8, "FPGA  Current Min  Max");

  char fpga[10];
  char tcurrent[10];
  char tmin[10];
  char tmax[10];

  AWL *labelFPGA [20];
  AWL *labelC[20];
  AWL *labelMin[20];
  AWL *labelMax[20];

  UInt32 fc=GfxColor (255,255,255);
  for (int i = 0; i< 10; i++) {
      int val1=rand() % 1000;
      int val2=rand() % 1000;
      int val3=rand() % 1000;
      sprintf (fpga, "%d", i);
      sprintf (tcurrent, "%03.1f", (float) (val1/10.0));
      sprintf (tmin, "%03.1f", (float) (val2/10.0));
      sprintf (tmax, "%03.1f", (float) (val3/10.0));
      int y = ((i+1)*10)+20;

      labelFPGA[i] = new AWL (dialogTemperature, 5, y, 45, 8, fpga);
      labelFPGA[i]->SetColors (0, 0, fc, GfxColor (0,0,255));
      labelC[i]    = new AWL (dialogTemperature, 70, y, 45, 8, tcurrent);
      labelC[i]->SetColors (0, 0, fc, GfxColor (255,0,255));
      labelMin[i]  = new AWL (dialogTemperature, 115, y, 45, 8, tmin);
      labelMin[i]->SetColors (0, 0, fc, GfxColor (0,255,255));
      labelMax[i]   = new AWL (dialogTemperature, 180, y, 45, 8, tmax);
      labelMax[i]->SetColors (0, 0, fc, GfxColor (255,0,0));
  }

  Application.AttachDialog (dialogTemperature);
  dialogTemperature->Show ();

  Application.MainLoop ();

  return 0;
}
